/////////This class represents a single Tile//////////

import waba.fx.*;
import waba.sys.*;

public final class Tile  
{
	private int SIZE = Memo24.SIZE;
	private int ROWS = Memo24.ROWS;
	
	private boolean open, correct;
	private int index, imageIndex, x, y;
	
	public Tile(int index, int imageIndex)
	{
		this.index = index;			
		this.imageIndex = imageIndex;
		
		if(this.imageIndex > 11)
			this.imageIndex -= 12;		
		
		//move the center tile to the lower right corner
		if(index == 12)	
			x = y = 240;
		else
		{
			x = index % ROWS * SIZE;		
			y = index / ROWS * SIZE;	
		}
	}
	
	public final void setOpen(boolean cover)
	{
		open = cover;
	} 
	
	public final boolean isOpen()
	{
		return open;
	}
		
	public final void setCorrect()
	{
		correct = true;
	}
	
	public final boolean isCorrect()
	{
		return correct;
	}
		
	public final int getIndex()
	{
		return index;
	}
	
	public final int getImageIndex()
	{
		return imageIndex;
	}
	
	public final boolean clickedAt(int stylusX, int stylusY)
	{
		Rect rect = new Rect(x, y, SIZE, SIZE);
		
		if(rect.contains(stylusX, stylusY))
			return true;
			
		return false;
	}
		
	public final Coord getCoord()
	{			
		return new Coord(x, y);
	}
}
